#include <windows.h>
#include <tchar.h>
#include "resource.h"

HINSTANCE g_hInst;

BOOL OpenDialog(LPTSTR lpFile, HWND hwndOwner)
{
	OPENFILENAME ofn;
	TCHAR chFile[_MAX_PATH];
	lstrcpy(chFile, "");
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFile = chFile;
	ofn.hwndOwner = hwndOwner;
	ofn.nMaxFile = sizeof(chFile);
	ofn.lpstrFilter = TEXT("Textov soubory (*.txt)\0*.txt\0Vechny soubory (*.*)\0*.*\0");
	ofn.nFilterIndex = 1;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	if ( !GetOpenFileName(&ofn) )
		return FALSE;
	lstrcpy(lpFile, chFile);
	return TRUE;
}

BOOL LoadFile(LPCTSTR lpFileName, HWND hWndTo)
{
	HANDLE hFile;
	DWORD dwSize;
	DWORD dw;
	LPBYTE lpBuffer = NULL;
	hFile =	CreateFile(lpFileName, GENERIC_READ, 0,NULL, OPEN_EXISTING, 0, NULL);
	if ( hFile == INVALID_HANDLE_VALUE )
		return FALSE;
	dwSize = GetFileSize(hFile, NULL);
	lpBuffer = (LPBYTE)HeapAlloc(GetProcessHeap(), HEAP_GENERATE_EXCEPTIONS, dwSize+1);
	if ( !ReadFile(hFile, lpBuffer, dwSize, &dw, NULL) )
	{
		CloseHandle(hFile);
		HeapFree(GetProcessHeap(), 0, lpBuffer);
		return FALSE;
	}
	CloseHandle(hFile);
	lpBuffer[dwSize] = 0;
	SetWindowText(hWndTo, (LPCTSTR)lpBuffer);
	if ( !HeapFree(GetProcessHeap(), 0, lpBuffer) )
		return FALSE;
	return TRUE;
}

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	TCHAR chFile[_MAX_PATH];
	switch ( uMsg )
	{
		case WM_INITDIALOG:
			SetClassLongPtr(hWnd, GCLP_HICONSM,	
				(LONG_PTR)LoadIcon(g_hInst, MAKEINTRESOURCE(IDR_MAIN)));
			break;
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDCANCEL:
				case IDOK:
					EndDialog(hWnd, LOWORD(wParam));
					break;
				case IDC_OPEN_FILE:
					if ( !OpenDialog(chFile, hWnd) )
						break;
					SetDlgItemText(hWnd, IDC_FILE_NAME, chFile);
					if ( !LoadFile(chFile, GetDlgItem(hWnd, IDC_FILE)) ) 
						MessageBox(hWnd, TEXT("Chyba pi naten souboru"),
							TEXT("CHYBA"), MB_ICONERROR | MB_APPLMODAL);
					break;
			}
			break;
	}
	return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nCmdShow)
{
	g_hInst = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL,
		(DLGPROC)DialogProc);
	return 0;
}
